C ... SAMPLE DRIVER FOR LESLIL ...
C LESLIL IS THE CODE FOR APPROXIMATING LYAPUNOV EXPONENTS
C OF (LARGE) LINEAR SYSTEMS.  IN THIS CASE, THE INFORMATION
C ON THE COEFFICIENT MATRIX MUST BE PROVIDED AS ACTION OF 
C THE COEFFICIENT MATRIX ON A VECTOR V (SEE GETAV)
      PROGRAM DRIV
      IMPLICIT NONE
C DECLARE VARIABLES NEEDED BY LESLIL

C COEFFICIENT MATRIX TIMES VECTOR DEFINED IN GETAV
      EXTERNAL GETAV
      INTEGER M, N
      PARAMETER (M=4,N=4)
      DOUBLE PRECISION T0, TE, DT, APPLES(N), Y0(M,N)
      INTEGER IPAR(13), IFLAG, IFDIM
      PARAMETER(IFDIM=11*M*N+8*N+63)
      DOUBLE PRECISION FWORK(IFDIM), REARR, TOLL(N), TOLQ
      INTEGER I, INARR

      DOUBLE PRECISION ACC
C VARIABLES TO GET CPU TIME: WATCOM COMPILER
C     INTEGER*2 HR1,HR2,MN1,MN2,SEC1,SEC2,HUN1,HUN2

CCCCCCC INPUT
CCCCCCC VARIABLE STEP SIZE -->0, FIXED STEP SIZE -->1
      IPAR(1) = 0
C ERROR TOLERANCES ALL THE SAME
      DO 2 I=1,N
         TOLL(I) = 1.D-6
 2    CONTINUE
      TOLQ=1.D-6
      TOLL(4)=1.D-3
CCCCCCC FROM T0 TO TE --> IPAR(2)=0, IF IN ONE STEP MODE --> IPAR(2)=1
      T0 = 0.0D0
      DT = 1.0D0*1.0D-1
      TE = 1.0D+2
      IPAR(2) = 0
CCCCCCC IT IS VERY FIRST CALL
      IPAR(3) = 1
C TO USE DEFAULT ICS ON Y0, SET IPAR(4) = 0 
      IPAR(4) = 0
CCCCCCC FWORK DIMENSION
      IPAR(5)=IFDIM
C DECIDE WHICH METHOD WANT TO USE 
C   IPAR(8)=0 (DEFAULT) IS PROJECTION/DP5
C   IPAR(8)=1 IS HYBRID/DP5
C   IPAR(8)=2 IS PROJECTION/RK38
C   IPAR(8)=3 IS HYBRID/RK38
C   IPAR(8)=4 IS DISC QR/DP5
C   IPAR(8)=5 IS DISC QR/RK38
      IPAR(8)=0
C DECIDE WHICH FORMULA TO USE TO APPROXIMATE EXPONENTS
C   IPAR(9)=0 (DEFAULT) IS NU-INTEGRATION 
C IN CASE YOU CHOSE IPAR(8)=0,1,2,3 YOU CAN SET ALSO
C   IPAR(9)=1 WHICH IS COMPOSITE TRAP-RULE 
      IPAR(9)=0
C DECIDE ON WHAT TO CONTROL ERROR IN VARIABLE STEPSIZE
C   IPAR(10)=0 IS ERROR CONTROL ON LEs 
C   IPAR(10)=1 IS ERROR CONTROL ON Q 
C   IPAR(10)=10 IS ERROR CONTROL ON LEs AND ON Q 
C SUGGESTED VALUES: 
C   IF IPAR(8)=0,1,2,3 AND IPAR(9)=0, USE IPAR(10)=10
C   IF IPAR(8)=0,1,2,3 AND IPAR(9)=1, USE IPAR(10)=1
C   IF IPAR(8)=4,5 MUST USE IPAR(10)=0
      IPAR(10)=10
C FIRST CALL TO GETTIM: THIS IS COMPILER DEPENDENT
C     CALL GETTIM(HR1, MN1, SEC1, HUN1)
C INITIALIZE CODE THE VERY FIRST TIME
      CALL INIT(M,N,IPAR,T0,TE,DT,TOLQ,TOLL,FWORK,IFLAG)
      IF (IFLAG.NE.0) THEN
         PRINT *, 'IFLAG = ', IFLAG
         STOP
      END IF
C INTEGRATE FROM T0 TO TE RETURNING OUTPUT EVERY 10 UNITS
 20   CONTINUE
C CALL MAIN ROUTINE
      CALL LESLIL(GETAV,M,N,APPLES,T0,TE,DT,
     *            Y0,TOLQ,TOLL,IPAR,FWORK,IFLAG,INARR,REARR)
      IF (IFLAG.NE.0) THEN
         PRINT *, 'IFLAG = ', IFLAG
         PRINT*, ' CURRENT T = ', T0,'  LYAP-EXPS ARE '
         WRITE(*,25) (APPLES(I),I=1,N)
         STOP
      ENDIF
C SECOND CALL TO GETTIM
C     CALL GETTIM(HR2, MN2, SEC2, HUN2)
      PRINT *, 'AT T= ',T0,'  LYAP-EXPS ARE '
      WRITE(*,25) (APPLES(I),I=1,N)
 25   FORMAT (2X,4(E16.8,2X))
      PRINT *
      ACC=0.0D0
      DO 26 I=1,N
 26      ACC=ACC+APPLES(I)
      PRINT*, ' SUM OF THE LES IS ',ACC
      PRINT *
      IF (T0.LT.1000.0D0) THEN
         TE=TE+100.D0
         GOTO 20
      ENDIF
C PRINT SOME STATISTICS
      IF (IPAR(8).EQ.0) THEN
         PRINT *, 'METHOD USED IS CONT QR WITH PROJ-DP5 '
        ELSE IF (IPAR(8).EQ.1) THEN
         PRINT *, 'METHOD USED IS CONT QR WITH HYBRID-DP5 '
        ELSE IF (IPAR(8).EQ.2) THEN
         PRINT *, 'METHOD USED IS CONT QR WITH PROJ-RK38 '
        ELSE IF (IPAR(8).EQ.3) THEN
         PRINT *, 'METHOD USED IS CONT QR WITH HYBRID-RK38 '
        ELSE IF (IPAR(8).EQ.4) THEN
         PRINT *, 'METHOD USED IS DISC QR WITH DP5 '
        ELSE IF (IPAR(8).EQ.5) THEN
         PRINT *, 'METHOD USED IS DISC QR WITH RK38 '
      ENDIF
      IF (IPAR(8).LE.3) THEN
         IF (IPAR(9).EQ.0) THEN
            PRINT *, 'LES BY NU-INTEGRATION '
           ELSE IF (IPAR(9).EQ.1) THEN
            PRINT *, 'LES BY COMP-TRAP-RULE '
         ENDIF
      ENDIF
      IF (IPAR(1).EQ.0) THEN
         IF (IPAR(10).EQ.0) THEN
            PRINT *, 'ERROR CONTROL ON LES '
           ELSE IF (IPAR(10).EQ.1) THEN
            PRINT *, 'ERROR CONTROL ON Q '
           ELSE IF (IPAR(10).EQ.10) THEN
            PRINT *, 'ERROR CONTROL ON Q AND LES '
         ENDIF
      ENDIF
      PRINT *, 'IFLAG = ', IFLAG, ' FINAL T = ', T0
      PRINT *, 'STEPS REJECTED = ', IPAR(12)
      PRINT *, 'NUMBER OF STEPS = ', IPAR(13)
C     WRITE (6,*) 'INITIAL TIME = ', HR1,MN1,SEC1,HUN1
C     WRITE (6,*) 'FINAL TIME = ', HR2,MN2,SEC2,HUN2

      STOP 
      END

C ... and this is the sample GETAV .... 

      SUBROUTINE GETAV(M,T,V,VDOT,INARR,REARR)
      IMPLICIT NONE

      INTEGER M, NN, INARR(*)
      PARAMETER (NN=4)
      DOUBLE PRECISION T, REARR(*)
      DOUBLE PRECISION V(M), VDOT(M)

      DOUBLE PRECISION AMAT(NN,NN)
      DOUBLE PRECISION QD(NN,NN), QMAT(NN,NN), AT(NN,NN)       

      INTEGER I, J

      DO 10 I=1,M
 10      VDOT(I)=0.D0

CCCCCCC PROBLEM MARCUS-YAMABE (N=2)
C      VDOT(1) = (-1.D0+1.5D0*DCOS(T)*DCOS(T))*V(1)+
C     1           (1.D0-1.5D0*DSIN(T)*DCOS(T))*V(2)
C      VDOT(2) = (-1.D0-1.5D0*DSIN(T)*DCOS(T))*V(1)+
C     1           (-1.D0+1.5D0*DSIN(T)*DSIN(T))*V(2)

      DO 15 I=1,M
         DO 15 J=1,M
 15         AMAT(I,J)=0.D0
CCCCCCC PROBLEM QP (N=4)
CCCCCCC FORM THE MATRIX (STORED IN UOUT)
      CALL BLDQ(M,T,QMAT,QD)
      DO 20 I=1,M
         DO 20 J=1,M
 20         AT(I,J) = 0.D0 
      AT(1,1) = 1.D0
      AT(2,2) = DCOS(T)
      AT(3,3) = -1.D0/(2.D0*DSQRT(T+1.D0))
      AT(4,4) = -10.D0 
      CALL BLDA(M,QMAT,QD,AT,AMAT)
      DO 30 I=1,M
         VDOT(I)=0.0D0
         DO 25 J=1,M
 25         VDOT(I)=VDOT(I)+AMAT(I,J)*V(J)
 30   CONTINUE

      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C*****Subroutine name: BLDQ 
C
C*****Purpose
C     Used to form an orthgonal matrix as part of 
C     the example problem nprob=2
C
C*****Authors: L Dieci & ES Van Vleck
C*****Date: August 2000
C
CCCCCCC ROUTINE BLDQ
      SUBROUTINE BLDQ(N,T,Q,QD)
      IMPLICIT NONE

      INTEGER N
      DOUBLE PRECISION T
      DOUBLE PRECISION Q(N,N), QD(N,N)

      INTEGER I,J
      DOUBLE PRECISION DRT2

      DRT2 = DSQRT(2.D0)
      DO 10 J=1,N
         DO 10 I=1,N
            QD(I,J) = 0.D0
 10         Q(I,J) = 0.D0
      Q(1,1) = DCOS(T)
      Q(1,2) = DSIN(T)
      Q(2,1) = -DSIN(T)*DCOS(DRT2*T)
      Q(2,2) = DCOS(T)*DCOS(DRT2*T)
      Q(2,3) = DCOS(T)*DSIN(DRT2*T)
      Q(2,4) = DSIN(T)*DSIN(DRT2*T)
      Q(3,1) = DSIN(T)*DSIN(DRT2*T)
      Q(3,2) = -DCOS(T)*DSIN(DRT2*T)
      Q(3,3) = DCOS(T)*DCOS(DRT2*T)
      Q(3,4) = DSIN(T)*DCOS(DRT2*T)
      Q(4,3) = -DSIN(T)
      Q(4,4) = DCOS(T)
      QD(1,1) = -DSIN(T)
      QD(1,2) = DCOS(T)
      QD(2,1) = -DCOS(T)*DCOS(DRT2*T)
     *          + DRT2*DSIN(T)*DSIN(DRT2*T)
      QD(2,2) = -DSIN(T)*DCOS(DRT2*T)
     *          - DRT2*DCOS(T)*DSIN(DRT2*T)
      QD(2,3) = -DSIN(T)*DSIN(DRT2*T)
     *          + DRT2*DCOS(T)*DCOS(DRT2*T)
      QD(2,4) = DCOS(T)*DSIN(DRT2*T)
     *          + DRT2*DSIN(T)*DCOS(DRT2*T)
      QD(3,1) = DCOS(T)*DSIN(DRT2*T)
     *          + DRT2*DSIN(T)*DCOS(DRT2*T)
      QD(3,2) = DSIN(T)*DSIN(DRT2*T)
     *          - DRT2*DCOS(T)*DCOS(DRT2*T)
      QD(3,3) = -DSIN(T)*DCOS(DRT2*T)
     *          - DRT2*DCOS(T)*DSIN(DRT2*T)
      QD(3,4) = DCOS(T)*DCOS(DRT2*T)
     *          - DRT2*DSIN(T)*DSIN(DRT2*T)
      QD(4,3) = -DCOS(T)
      QD(4,4) = -DSIN(T)

      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C*****Subroutine name: BLDA 
C
C*****Purpose
C     Forms the coefficient matrix for the example
C     problem with nprob=2
C
C*****Authors: L Dieci & ES Van Vleck
C*****Date: August 2000
C
CCCCCCCC ROUTINE BLDA
      SUBROUTINE BLDA(M,QMAT,QD,AT,A)
      IMPLICIT NONE

      INTEGER M
      INTEGER NN
      PARAMETER (NN=4)
      INTEGER NPROB
      DOUBLE PRECISION ALP, BET, EPS
      COMMON /PARAMS/ ALP, BET, EPS, NPROB
      DOUBLE PRECISION QMAT(M,M), QD(M,M), A(M,M), AT(M,M)

      DOUBLE PRECISION QTMP1(NN,NN), QTMP2(NN,NN)
      INTEGER I, J

      CALL MATTMT(QMAT,M,M,M,AT,A)
      CALL MATTMH(A,M,M,M,QMAT,QTMP1)
      CALL MATTMH(QD,M,M,M,QMAT,QTMP2)
      DO 10 J=1,M
         DO 10 I=1,M
 10         A(I,J) = QTMP1(I,J) + QTMP2(I,J)

      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C*****Subroutine name: MATTMT 
C
C*****Purpose
C     Forms the matrix product of two matrices.
C
C*****Authors: L Dieci & ES Van Vleck
C*****Date: August 2000
C
CCCCCCCCCCCCCCCCCC MATTMT CCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MATTMT(A,N1,N2,N3,B,C)
      IMPLICIT NONE

      INTEGER N1,N2,N3
      DOUBLE PRECISION A(N1,N2), B(N2,N3), C(N1,N3)
      INTEGER I,J,K

      DO 10 J=1,N3
         DO 10 I=1,N1
            C(I,J) = 0.D0
            DO 10 K=1,N2
 10            C(I,J) = C(I,J) + A(I,K)*B(K,J)

      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C*****Subroutine name: MATHTM
C
C*****Purpose
C     Forms the matrix product A^T B.
C
C*****Authors: L Dieci & ES Van Vleck
C*****Date: August 2000
C
CCCCCCCCCCCCCCCCCC MATHTM CCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MATHTM(A,N1,N2,N3,B,C)
      IMPLICIT NONE

      INTEGER N1,N2,N3
      DOUBLE PRECISION A(N2,N1), B(N2,N3), C(N1,N3)
      INTEGER I,J,K

      DO 10 J=1,N3
         DO 10 I=1,N1
            C(I,J) = 0.D0
            DO 10 K=1,N2
 10            C(I,J) = C(I,J) + A(K,I)*B(K,J)

      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C*****Subroutine name: MATTMH
C
C*****Purpose
C     Forms the matrix product A B^T.
C
C*****Authors: L Dieci & ES Van Vleck
C*****Date: August 2000
C
CCCCCCCCCCCCCCCCCC MATTMH CCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MATTMH(A,N1,N2,N3,B,C)
      IMPLICIT NONE

      INTEGER N1,N2,N3
      DOUBLE PRECISION A(N1,N2), B(N3,N2), C(N1,N3)
      INTEGER I,J,K

      DO 10 J=1,N3
         DO 10 I=1,N1
            C(I,J) = 0.D0
            DO 10 K=1,N2
 10            C(I,J) = C(I,J) + A(I,K)*B(J,K)

      RETURN
      END

