C ... SAMPLE DRIVER FOR LESLIS ...
C LESLIS IS THE CODE FOR APPROXIMATING LYAPUNOV EXPONENTS
C OF (SMALL) LINEAR SYSTEMS.  IN THIS CASE, THE 
C COEFFICIENT MATRIX MUST BE PROVIDED (SEE GETA)
      PROGRAM DRIV
      IMPLICIT NONE
C DECLARE VARIABLES NEEDED BY LESLIS

C COEFFICIENT MATRIX DEFINED IN GETA
      EXTERNAL GETA
      INTEGER M, N
      PARAMETER (M=4,N=4)
      DOUBLE PRECISION T0, TE, DT, TOLL(N), APPLES(N), Y0(M,N)
      INTEGER IPAR(13), IFLAG, IFDIM
      PARAMETER(IFDIM=M*M+11*M*N+8*N+63)
      DOUBLE PRECISION FWORK(IFDIM), REARR, TOLQ
      INTEGER I, INARR

      DOUBLE PRECISION ACC
C VARIABLES TO GET CPU TIME: WATCOM COMPILER
C     INTEGER*2 HR1,HR2,MN1,MN2,SEC1,SEC2,HUN1,HUN2
C PARAMETERS FOR GETA
      INTEGER NPROB
      DOUBLE PRECISION ALP, BET, EPS
      COMMON /PARAMS/ ALP, BET, EPS, NPROB

C WE SOLVE PROBLEM 2 OF THE COLLECTION IN "user.f" 
      NPROB=2
      ALP=1.0D0
      BET=1.0D0
      EPS=1.0D-1
CCCCCCC INPUT
CCCCCCC VARIABLE STEP SIZE -->0, FIXED STEP SIZE -->1
      IPAR(1) = 0
C ERROR TOLERANCES
      DO 2 I=1,N
         TOLL(I) = 1.D-6
 2    CONTINUE
      TOLQ=1.D-6
      TOLL(N)=1.D-3
CCCCCCC FROM T0 TO TE --> IPAR(2)=0, IF IN ONE STEP MODE --> IPAR(2)=1
      T0 = 0.0D0
C NEED TO SET DT IN FIXED STEPSIZE MODE
C      DT = 1.0D0*1.0D-1
      TE = 1.0D+2
      IPAR(2) = 0
CCCCCCC IT IS VERY FIRST CALL
      IPAR(3) = 1
C TO USE DEFAULT ICS ON Y0, SET IPAR(4) = 0 
      IPAR(4) = 0
CCCCCCC FWORK DIMENSION
      IPAR(5)=IFDIM
C DECIDE WHICH METHOD WANT TO USE
C   IPAR(8)=0 (DEFAULT) IS PROJECTION/DP5
C   IPAR(8)=1 IS HYBRID/DP5
C   IPAR(8)=2 IS PROJECTION/RK38
C   IPAR(8)=3 IS HYBRID/RK38
C   IPAR(8)=4 IS DISC QR/DP5
C   IPAR(8)=5 IS DISC QR/RK38
      IPAR(8)=0
C DECIDE WHICH FORMULA TO USE TO APPROXIMATE EXPONENTS
C   IPAR(9)=0 (DEFAULT) IS NU-INTEGRATION 
C IN CASE YOU CHOSE IPAR(8)=0,1,2,3 YOU CAN SET ALSO
C   IPAR(9)=1 WHICH IS COMPOSITE TRAP-RULE 
      IPAR(9)=0
C DECIDE ON WHAT TO CONTROL ERROR IN VARIABLE STEPSIZE
C   IPAR(10)=0 IS ERROR CONTROL ON LEs 
C   IPAR(10)=1 IS ERROR CONTROL ON Q 
C   IPAR(10)=10 IS ERROR CONTROL ON LEs AND ON Q 
C SUGGESTED VALUES: 
C   IF IPAR(8)=0,1,2,3 AND IPAR(9)=0, USE IPAR(10)=10
C   IF IPAR(8)=0,1,2,3 AND IPAR(9)=1, USE IPAR(10)=1
C   IF IPAR(8)=4,5 MUST USE IPAR(10)=0
      IPAR(10)=10
C FIRST CALL TO GETTIM: THIS IS COMPILER DEPENDENT
C     CALL GETTIM(HR1, MN1, SEC1, HUN1)
C INITIALIZE CODE THE VERY FIRST TIME
      CALL INIT(M,N,IPAR,T0,TE,DT,TOLQ,TOLL,FWORK,IFLAG)
      IF (IFLAG.NE.0) THEN
         PRINT *, 'IFLAG = ', IFLAG
         STOP
      END IF
C INTEGRATE FROM T0 TO TE RETURNING OUTPUT EVERY 100 UNITS
 20   CONTINUE
C CALL MAIN ROUTINE
      CALL LESLIS(GETA,M,N,APPLES,T0,TE,DT,
     *            Y0,TOLQ,TOLL,IPAR,FWORK,IFLAG,INARR,REARR)
      IF (IFLAG.NE.0) THEN
         PRINT *, 'IFLAG = ', IFLAG
         PRINT*, ' CURRENT T = ', T0,'  LYAP-EXPS ARE '
         WRITE(*,25) (APPLES(I),I=1,N)
         STOP
      ENDIF
C SECOND CALL TO GETTIM
C     CALL GETTIM(HR2, MN2, SEC2, HUN2)
      PRINT *, 'AT T= ',T0,'  LYAP-EXPS ARE '
      WRITE(*,25) (APPLES(I),I=1,N)
 25   FORMAT (2X,4(E16.8,2X))
      PRINT *
      ACC=0.0D0
      DO 26 I=1,N
 26      ACC=ACC+APPLES(I)
      PRINT*, ' SUM OF THE LES IS ',ACC
      PRINT *
      IF (T0.LT.1000.0D0) THEN
         TE=TE+100.D0
         GOTO 20
      ENDIF
C PRINT SOME STATISTICS
      IF (IPAR(8).EQ.0) THEN
         PRINT *, 'METHOD USED IS CONT QR WITH PROJ-DP5 '
        ELSE IF (IPAR(8).EQ.1) THEN
         PRINT *, 'METHOD USED IS CONT QR WITH HYBRID-DP5 '
        ELSE IF (IPAR(8).EQ.2) THEN
         PRINT *, 'METHOD USED IS CONT QR WITH PROJ-RK38 '
        ELSE IF (IPAR(8).EQ.3) THEN
         PRINT *, 'METHOD USED IS CONT QR WITH HYBRID-RK38 '
        ELSE IF (IPAR(8).EQ.4) THEN
         PRINT *, 'METHOD USED IS DISC QR WITH DP5 '
        ELSE IF (IPAR(8).EQ.5) THEN
         PRINT *, 'METHOD USED IS DISC QR WITH RK38 '
      ENDIF
      IF (IPAR(8).LE.3) THEN
         IF (IPAR(9).EQ.0) THEN
            PRINT *, 'LES BY NU-INTEGRATION '
           ELSE IF (IPAR(9).EQ.1) THEN
            PRINT *, 'LES BY COMP-TRAP-RULE '
         ENDIF
      ENDIF
      IF (IPAR(1).EQ.0) THEN
         IF (IPAR(10).EQ.0) THEN
            PRINT *, 'ERROR CONTROL ON LES '
           ELSE IF (IPAR(10).EQ.1) THEN
            PRINT *, 'ERROR CONTROL ON Q '
           ELSE IF (IPAR(10).EQ.10) THEN
            PRINT *, 'ERROR CONTROL ON Q AND LES '
         ENDIF
      ENDIF
      PRINT *, 'IFLAG = ', IFLAG, ' FINAL T = ', T0
      PRINT *, 'STEPS REJECTED = ', IPAR(12)
      PRINT *, 'NUMBER OF STEPS = ', IPAR(13)
C     WRITE (6,*) 'INITIAL TIME = ', HR1,MN1,SEC1,HUN1
C     WRITE (6,*) 'FINAL TIME = ', HR2,MN2,SEC2,HUN2

      STOP 
      END

